clubs/urls.py
from django.urls import path
from .import views

app_name = 'clubs'
urlpatterns = [
    path('', views.clubshome, name='clubshome'),
    path('history/', views.clubs_history, name='history'),
]

dpi_sms/urls.py
from django.contrib import admin
from django.urls import path, include
from mainapp.views import redirectView
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    #stands for homepage
    path('welcome/', include('mainapp.urls')),
    #regx will say for whom it's been made :p
    path('', redirectView),
    path('clubs/', include('clubs.urls')),
    path('teachers/', include('teachers.urls')),
]


urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

clubs/models.py
from django.db import models


class Club(models.Model):
    name = models.CharField(max_length=30)
    description = models.TextField()
    coach = models.ForeignKey('teachers.Teacher', on_delete=models.CASCADE)

    def __str__(self):
        return self.name
    
    def short_desc(self):
        return self.description[:100]+'...'


class Activity(models.Model):
    club = models.ForeignKey(Club, on_delete=models.CASCADE)
    session_no = models.CharField(max_length=4)
    date = models.DateField()
    mentor = models.ForeignKey('teachers.Teacher', on_delete=models.CASCADE)

    def __str__(self):
        return str(self.club)

clubs/views.py
from django.shortcuts import render
from clubs.models import Club, Activity


def clubshome(request):
    topclubs = Club.objects.all()[:4]
    allclubs = Club.objects.all()
    activities = Activity.objects.order_by('-date')
    context = {
        'topclubs': topclubs,
        'allclubs': allclubs,
        'activities': activities,
    }
    return render(request, 'clubs/clubshome.html', context)


def clubs_history(request):
    clubs = Activity.objects.order_by('-date')
    context = {
        'clubs': clubs,
    }
    return render(request, 'clubs/history.html', context)

templates/clubs/clubshome.html
{% extends 'base.html' %}
{% load static %}
{% block body %}

<div class="col-md-12 border rounded p-2">
    <div class="container-fluid">
        <div class="row">
            {% for club in topclubs %}
            <div class="col-md-3 text-center py-1">
                <img class="rounded-circle" src="{% static 'clubs/images/club-icon.png' %}" alt="logo" height="100" width="100">
                <h4 id="clubname">{{ club.name }}</h4>
            </div>
            {% endfor %}
        </div>
    </div>
</div>

<div class="col-md-12 mt-3 m-0 p-0 border-bottom pb-3">
    <button type="button" class="btn bg-custom1 mt-5" style="cursor:default">Club activities</button>
    <a href="#" class="btn bg-custom1-dark mt-5 ml-2">
        Arrange new
        <i class="fas fa-plus ml-1"></i>
    </a>
    <table class="table table-bordered mt-2">
        <thead>
            <tr>
                <th scope="col">Club</th>
                <th scope="col">Session</th>
                <th scope="col">Date</th>
                <th scope="col">Action</th>
            </tr>
        </thead>
        <tbody>
            {% for activity in activities|slice:":4" %}
            <tr>
                <td style="width: 27%">{{ activity.club }}</td>
                <td style="width: 27%">{{ activity.session_no }}</td>
                <td style="width: 27%">{{ activity.date }}</td>
                <td style="width: 10%;">
                    <div class="btn-group-sm mx-auto" role="group" aria-label="Basic example">
                        <button type="button" class="btn bg-custom1-dark"><i class="fas fa-pen-square"></i></button>
                        <button type="button" class="btn bg-custom1"><i class="far fa-trash-alt"></i></button>
                    </div>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
    <a href="{% url 'clubs:history' %}" class="btn bg-custom1 mt-2 float-right">
        <i class="fas fa-forward mr-1"></i>Show all
    </a>   
</div>

<!-- Club Detail -->
<button type="button" class="btn bg-custom1 mt-5">Club details</button>
<div class="containerfluid">
    <div class="row" id="noxpadding">
        {% for clb in allclubs %}
        <div class="col-md-4 my-2 text-center">
            <div class="card-group">
                <div class="card">
                    <img class="card-img-top" src="{% static 'clubs/images/placeholder.png' %}" alt="Card image cap">
                    <div class="card-body">
                        <h5 class="card-title">{{ clb.name }}</h5>
                        <p class="card-text">{{ clb.short_desc }}</p>
                    </div>
                    <div class="card-footer">
                        <p><strong>{{ clb.coach }}</strong></p>
                    </div>
                </div>
            </div>
        </div>
        {% endfor %}
    </div>
</div>

{% endblock %}

templates/clubs/history.html
{% extends 'base.html' %}
{% load static %}
{% block body %}

<div class="col-md-12 m-0 p-0 pb-3">
    <button type="button" class="btn bg-custom1">All activities</button>
    <a href="#" class="btn bg-custom1-dark ml-2">
        Arrange new
        <i class="fas fa-plus ml-1"></i>
    </a>
    <a href="{% url 'clubs:clubshome' %}" class="btn bg-custom1 float-right">
        <i class="fas fa-backward mr-1"></i>Back to club
    </a>
    <table class="table table-bordered mt-2">
        <thead>
            <tr>
                <th scope="col">Club</th>
                <th scope="col">Session</th>
                <th scope="col">Date</th>
                <th scope="col">Action</th>
            </tr>
        </thead>
        <tbody>
            {% for record in clubs %}
            <tr>
                <td style="width: 27%">{{ record.club }}</td>
                <td style="width: 27%">{{ record.session_no }}</td>
                <td style="width: 27%">{{ record.date }}</td>
                <td style="width: 10%;">
                    <div class="btn-group-sm mx-auto" role="group" aria-label="Basic example">
                        <button type="button" class="btn btn-success"><i class="fas fa-pen-square"></i></button>
                        <button type="button" class="btn btn-danger"><i class="far fa-trash-alt"></i></button>
                    </div>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</div>

{% endblock %}